package com.sagacloud.utils;

/**
 * Created by wo on 9/7/17.
 */
public class DecimalTONBigit {

    final static char[] digits = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz".toCharArray();
    final static int system = digits.length;

    /**
     * 将十进制的数字转换为指定进制的字符串。
     * @param i 十进制的数字。
     * @return 转换后的字符串。
     */
    public static String toString(int i ) {
        long num = 0;
        if (i < 0) {
            num = ((long)2 * 0x7fffffff) + i + 2;
        } else {
            num = i;
        }
        char[] buf = new char[32];
        int charPos = 32;
        while ((num / system) > 0) {
            buf[--charPos] = digits[(int)(num % system)];
            num /= system;
        }
        buf[--charPos] = digits[(int)(num % system)];
        return new String(buf, charPos, (32 - charPos));
    }

    /**
     * 将其它进制的数字（字符串形式）转换为十进制的数字。
     * @param s 其它进制的数字（字符串形式）
     * @return 转换后的数字。
     */
    public static int toInt(String s ) {
        char[] buf = new char[s.length()];
        s.getChars(0, s.length(), buf, 0);
        long num = 0;
        for (int i=0;i<buf.length;i++) {
            for (int j=0;j<digits.length;j++) {
                if (digits[j] == buf[i]) {
                    num += j * Math.pow(system, buf.length - i -1);
                    break;
                }
            }
        }
        return (int)num;
    }



    /**
     * 十进制数（可以为负数）转n(n在[2,36]之间)进制
     * @author wl
     */
    public static void main(String[] args) {
//        int data=37;//data表示要转换的数
//        toNBigit(data,N);
        /*for (int i = 0; i < 63; i++) {
            System.out.print(toString(i));
            System.out.print(", ");
        }*/
        System.out.println(String.format("%1$4s", "ab").replace(' ', '0'));
        System.out.println(toInt("aa."));
        String a = "d";
        switch (a){
            case "a":
                String str = "hhh";
                System.out.println(str);
//                break;
            case "d":
                str = "bbbbb";
                System.out.println(str);
        }
    }


}

